#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-edges.html

module Bindings.Gts.GeometricalObjectHierarchy.Edges where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_EDGE_CLASS , Ptr a -> Ptr <GtsEdgeClass>
#cinline GTS_EDGE , Ptr a -> Ptr <GtsEdge>
#cinline GTS_IS_EDGE , Ptr a -> Ptr <gboolean> 

#ccall gts_edge_class , IO (Ptr <GtsEdgeClass>) 
#ccall gts_edge_new , Ptr <GtsEdgeClass> -> Ptr <GtsVertex> -> Ptr <GtsVertex> -> IO (Ptr <GtsEdge>) 
#ccall gts_edge_replace , Ptr <GtsEdge> -> Ptr <GtsEdge> -> IO ()

#cinline gts_edge_is_unattached , Ptr <GtsEdge> -> IO <gboolean>

#ccall gts_edge_is_duplicate , Ptr <GtsEdge> -> IO (Ptr <GtsEdge>) 
#ccall gts_edge_has_parent_surface , Ptr <GtsEdge> -> Ptr <GtsSurface> -> IO (Ptr <GtsFace>) 
#ccall gts_edge_has_any_parent_surface , Ptr <GtsEdge> -> IO (Ptr <GtsFace>) 
#ccall gts_edge_is_boundary , Ptr <GtsEdge> -> Ptr <GtsSurface> -> IO (Ptr <GtsFace>) 
#ccall gts_edge_is_contact , Ptr <GtsEdge> -> IO <guint>
#ccall gts_edge_belongs_to_tetrahedron , Ptr <GtsEdge> -> IO <gboolean>
#ccall gts_edge_face_number , Ptr <GtsEdge> -> Ptr <GtsSurface> -> IO <guint>
#ccall gts_edge_manifold_faces , Ptr <GtsEdge> -> Ptr <GtsSurface> -> Ptr (Ptr <GtsFace>) -> Ptr (Ptr <GtsFace>) -> IO <gboolean>
#ccall gts_edge_is_encroached , Ptr <GtsEdge> -> Ptr <GtsSurface> -> <GtsEncroachFunc> -> <gpointer> -> IO (Ptr <GtsVertex>) 
#ccall gts_edges_merge , Ptr <GList> -> IO (Ptr <GList>) 
#ccall gts_edges_from_vertices , Ptr <GSList> -> Ptr <GtsSurface> -> IO (Ptr <GSList>) 
#ccall gts_edge_swap , Ptr <GtsEdge> -> Ptr <GtsSurface> -> IO ()
