#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-object-class.html>

module Bindings.Gts.GeometricalObjectHierarchy.ObjectClass where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#num GTS_CLASS_NAME_LENGTH

#cinline GTS_OBJECT_CLASS , Ptr a -> Ptr <GtsObjectClass>
#cinline GTS_OBJECT , Ptr a -> Ptr <GtsObject>
#cinline GTS_IS_OBJECT , Ptr a -> Ptr <gboolean> 

#cinline GTS_OBJECT_FLAGS , Ptr a -> IO <guint32>
#cinline GTS_OBJECT_SET_FLAGS , Ptr a -> <guint32> -> IO ()
#cinline GTS_OBJECT_UNSET_FLAGS , Ptr a -> <guint32> -> IO ()
#cinline GTS_OBJECT_DESTROYED , Ptr a -> IO <gboolean>

#ccall gts_object_class , IO (Ptr <GtsObjectClass>) 
#ccall gts_object_class_new , Ptr <GtsObjectClass> -> Ptr <GtsObjectClassInfo> -> IO <gpointer>
#ccall gts_object_class_check_cast , <gpointer> -> <gpointer> -> IO <gpointer>

#cinline gts_object_class_is_from_class , <gpointer> -> <gpointer> -> IO <gpointer>

#ccall gts_object_class_from_name , Ptr <gchar> -> IO (Ptr <GtsObjectClass>) 
#ccall gts_object_new , Ptr <GtsObjectClass> -> IO (Ptr <GtsObject>) 
#ccall gts_object_init , Ptr <GtsObject> -> Ptr <GtsObjectClass> -> IO ()
#ccall gts_object_clone , Ptr <GtsObject> -> IO (Ptr <GtsObject>) 
#ccall gts_object_attributes , Ptr <GtsObject> -> Ptr <GtsObject> -> IO ()
#ccall gts_object_check_cast , <gpointer> -> <gpointer> -> IO <gpointer>

#cinline gts_object_is_from_class , <gpointer> -> <gpointer> -> IO <gpointer>

#ccall gts_object_reset_reserved , Ptr <GtsObject> -> IO ()
#ccall gts_object_destroy , Ptr <GtsObject> -> IO ()
#ccall gts_finalize , IO ()
