#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-points.html>

module Bindings.Gts.GeometricalObjectHierarchy.Points where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_POINT_CLASS , Ptr a -> Ptr <GtsPointClass>
#cinline GTS_POINT , Ptr a -> Ptr <GtsPoint>
#cinline GTS_IS_POINT , Ptr a -> Ptr <gboolean> 

#ccall gts_point_class , IO (Ptr <GtsPointClass>) 
#ccall gts_point_new , Ptr <GtsPointClass> -> <gdouble> -> <gdouble> -> <gdouble> -> IO (Ptr <GtsPoint>) 
#ccall gts_point_set , Ptr <GtsPoint> -> <gdouble> -> <gdouble> -> <gdouble> -> IO ()

#cinline gts_point_is_in_rectangle , Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gboolean>

#ccall gts_segment_triangle_intersection , Ptr <GtsSegment> -> Ptr <GtsTriangle> -> <gboolean> -> Ptr <GtsPointClass> -> IO (Ptr <GtsPoint>) 
#ccall gts_point_transform , Ptr <GtsPoint> -> Ptr <GtsMatrix> -> IO ()
#ccall gts_point_distance , Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gdouble>
#ccall gts_point_distance2 , Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gdouble>
#ccall gts_point_orientation_3d , Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gdouble>
#ccall gts_point_orientation_3d_sos , Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gint>

#ccall gts_point_in_circle , Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gdouble>
#ccall gts_point_in_triangle_circle , Ptr <GtsPoint> -> Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_point_is_in_triangle , Ptr <GtsPoint> -> Ptr <GtsTriangle> -> IO <GtsIntersect>
#ccall gts_point_orientation , Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gdouble>
#ccall gts_point_orientation_sos , Ptr <GtsPoint> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO <gint>
#ccall gts_point_segment_distance2 , Ptr <GtsPoint> -> Ptr <GtsSegment> -> IO <gdouble>
#ccall gts_point_segment_distance , Ptr <GtsPoint> -> Ptr <GtsSegment> -> IO <gdouble>
#ccall gts_point_segment_closest , Ptr <GtsPoint> -> Ptr <GtsSegment> -> Ptr <GtsPoint> -> IO ()
#ccall gts_point_triangle_distance , Ptr <GtsPoint> -> Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_point_triangle_closest , Ptr <GtsPoint> -> Ptr <GtsTriangle> -> Ptr <GtsPoint> -> IO ()
#ccall gts_point_triangle_distance2 , Ptr <GtsPoint> -> Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_point_is_inside_surface , Ptr <GtsPoint> -> Ptr <GNode> -> <gboolean> -> IO <gboolean>
