#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-vertices.html>

module Bindings.Gts.GeometricalObjectHierarchy.Vertices where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_VERTEX_CLASS , Ptr a -> Ptr <GtsVertexClass>
#cinline GTS_VERTEX , Ptr a -> Ptr <GtsVertex>
#cinline GTS_IS_VERTEX , Ptr a -> Ptr <gboolean> 

#ccall gts_vertex_class , IO (Ptr <GtsVertexClass>) 
#ccall gts_vertex_new , Ptr <GtsVertexClass> -> <gdouble> -> <gdouble> -> <gdouble> -> IO (Ptr <GtsVertex>) 
#ccall gts_vertex_is_unattached , Ptr <GtsVertex> -> IO <gboolean>
#ccall gts_vertex_is_boundary , Ptr <GtsVertex> -> Ptr <GtsSurface> -> IO <gboolean>
#ccall gts_vertex_is_contact , Ptr <GtsVertex> -> <gboolean> -> IO <guint>
#ccall gts_vertices_are_connected , Ptr <GtsVertex> -> Ptr <GtsVertex> -> IO (Ptr <GtsSegment>) 
#ccall gts_vertex_replace , Ptr <GtsVertex> -> Ptr <GtsVertex> -> IO ()
#ccall gts_vertex_neighbors , Ptr <GtsVertex> -> Ptr <GSList> -> Ptr <GtsSurface> -> IO (Ptr <GSList>) 
#ccall gts_vertex_triangles , Ptr <GtsVertex> -> Ptr <GSList> -> IO (Ptr <GSList>) 
#ccall gts_vertex_faces , Ptr <GtsVertex> -> Ptr <GtsSurface> -> Ptr <GSList> -> IO (Ptr <GSList>) 
#ccall gts_vertex_fan_oriented , Ptr <GtsVertex> -> Ptr <GtsSurface> -> IO (Ptr <GSList>) 
#ccall gts_vertex_encroaches_edge , Ptr <GtsVertex> -> Ptr <GtsEdge> -> IO <gboolean>
#ccall gts_vertices_from_segments , Ptr <GSList> -> IO (Ptr <GSList>) 
#ccall gts_vertices_merge , Ptr <GList> -> <gdouble> -> FunPtr (Ptr <GtsVertex> -> Ptr <GtsVertex> -> IO <gboolean>) -> IO (Ptr <GList>) 
