#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-delaunay-and-constrained-delaunay-triangulations.html>

module Bindings.Gts.SurfaceOperations.DelaunayAndConstrainedDelaunayTriangulations where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_CONSTRAINT_CLASS , Ptr a -> Ptr <GtsConstraintClass>
#cinline GTS_CONSTRAINT , Ptr a -> Ptr <GtsConstraint>
#cinline GTS_IS_CONSTRAINT , Ptr a -> Ptr <gboolean> 

#ccall gts_constraint_class , IO (Ptr <GtsConstraintClass>) 
#ccall gts_point_locate , Ptr <GtsPoint> -> Ptr <GtsSurface> -> Ptr <GtsFace> -> IO (Ptr <GtsFace>) 
#ccall gts_delaunay_add_vertex , Ptr <GtsSurface> -> Ptr <GtsVertex> -> Ptr <GtsFace> -> IO (Ptr <GtsVertex>) 
#ccall gts_delaunay_add_vertex_to_face , Ptr <GtsSurface> -> Ptr <GtsVertex> -> Ptr <GtsFace> -> IO (Ptr <GtsVertex>) 
#ccall gts_delaunay_remove_vertex , Ptr <GtsSurface> -> Ptr <GtsVertex> -> IO ()
#ccall gts_delaunay_add_constraint , Ptr <GtsSurface> -> Ptr <GtsConstraint> -> IO (Ptr <GSList>) 
#ccall gts_delaunay_check , Ptr <GtsSurface> -> IO (Ptr <GtsFace>) 
#ccall gts_delaunay_remove_hull , Ptr <GtsSurface> -> IO ()
#ccall gts_delaunay_conform , Ptr <GtsSurface> -> <gint> -> <GtsEncroachFunc> -> <gpointer> -> IO <guint>
#ccall gts_delaunay_refine , Ptr <GtsSurface> -> <gint> -> <GtsEncroachFunc> -> <gpointer> -> <GtsKeyFunc> -> <gpointer> -> IO <guint>
